Name:           python-exabgp
Version:        4.2.21
Release:    1%{?dist}
Summary:        The BGP swiss army knife of networking (Library)

License:        BSD-3-Clause
URL:            https://github.com/Exa-Networks/exabgp
Source0:        https://github.com/Exa-Networks/exabgp/archive/%{name}-%{version}.tar.gz
Source1:        exabgp.sysusers.exabgp.conf
Source2:        exabgp.tmpfiles.exabgp.conf
Source3:        exabgp.systemd.exabgp.service
Source4:        exabgp.systemd.exabgp@.service

Patch0001:      0001-update-six.patch

BuildArch:      noarch

%description
ExaBGP python module

%package -n python3-exabgp
Summary:        The BGP swiss army knife of networking
BuildRequires:  python3-devel
Requires:       python3 >= 3.7
%{?python_provide:%python_provide python3-exabgp}

%description -n python3-exabgp
The BGP swiss army knife of networking

%package -n exabgp
Summary:        The BGP swiss army knife of networking
BuildRequires:  systemd-rpm-macros
Requires:       systemd
Requires:       python3-exabgp = %{version}-%{release}

%description -n exabgp
The BGP swiss army knife of networking (exabgp systemd unit)

%prep
%autosetup -p1 -n exabgp-%{version}

%generate_buildrequires
%pyproject_buildrequires -t

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files exabgp

mkdir -p %{buildroot}%{_sbindir}
mv %{buildroot}%{_bindir}/exabgp %{buildroot}%{_sbindir}/

install -p -m 0755 bin/healthcheck %{buildroot}%{_sbindir}/exabgp-healthcheck

install -p -m 0755 bin/exabgpcli %{buildroot}%{_bindir}/

mkdir -p %{buildroot}%{_sysconfdir}/exabgp
touch %{buildroot}%{_sysconfdir}/exabgp/exabgp.env

mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}/exabgp.service
install -p -m 0644 %{SOURCE4} %{buildroot}%{_unitdir}/exabgp@.service

mkdir -p %{buildroot}%{_mandir}/man1
install -p -m 0644 doc/man/exabgp.1 %{buildroot}%{_mandir}/man1/
mkdir -p %{buildroot}%{_mandir}/man5
install -p -m 0644 doc/man/exabgp.conf.5 %{buildroot}%{_mandir}/man5/

mkdir -p %{buildroot}%{_sysusersdir}
install -p -m 0644 %{SOURCE1} %{buildroot}%{_sysusersdir}/exabgp.conf

mkdir -p %{buildroot}%{_tmpfilesdir}
install -p -m 0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/exabgp.conf

rm -rf %{buildroot}%{_usr}/etc

%check
%tox

%pre -n exabgp
%sysusers_create_package exabgp %{SOURCE1}
%tmpfiles_create_package exabgp %{SOURCE2}

%post -n exabgp
%systemd_post exabgp.service
[ -f %{_sysconfdir}/exabgp/exabgp.env ] || %{_sbindir}/exabgp --full-ini > %{_sysconfdir}/exabgp/exabgp.env

%preun -n exabgp
%systemd_preun exabgp.service

%postun -n exabgp
%systemd_postun_with_restart exabgp.service

%files -n python3-exabgp -f %{pyproject_files}
%doc README.md
%license LICENCE.txt

%files -n exabgp
%{_bindir}/exabgp-healthcheck
%{_bindir}/exabgpcli
%{_bindir}/exabgp-cli
%{_sbindir}/exabgp
%{_sbindir}/exabgp-healthcheck
%dir %{_sysconfdir}/exabgp
%ghost %{_sysconfdir}/exabgp/exabgp.env
%{_unitdir}/exabgp.service
%{_unitdir}/exabgp@.service
%{_mandir}/man1/exabgp.1{,.*}
%{_mandir}/man5/exabgp.conf.5{,.*}
%{_sysusersdir}/exabgp.conf
%{_tmpfilesdir}/exabgp.conf

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.2.21-1
- initial build
